#include "Form1.frm"
#include "FileIO.ch"

/*
 * Evento OnCreate.
 */
METHOD Form1OnCreate( oSender ) CLASS TForm1

   SET CENTURY ON
   SET DATE TO BRITISH
   
   ::FPreview := TPreview():Create( Self )
   ::FPreview:Visible := .F.
   ::FPreview:OnPageChanged := { || ::FPagina:Caption := "Pgina " + LTrim( Transform( ::FPreview:Page, "@E 999,999" ) ) }
   ::FPreview:OnZoomChanged := { || If( ::FPreview:Zoom == 0, ::FPaginaCompleta:Down := .T., If( ::FPreview:Zoom == 1, ::FPaginaNormal:Down := .T., ::FPaginaZoom:Down := .T. ) ) }

   Application:OnShowHint := { | cHint | ::FPanelMensajeNormal:Caption := If( Empty( cHint ), ;
                               "Seleccione una opcin.", cHint ), ;
                               ::FPanelMensajePreview:Caption := ::FPanelMensajeNormal:Caption }
   Printer:OnPreview := { || ShowPreview( .T. ) }

return

/*
 * Evento OnResize.
 */
METHOD Form1OnResize( oSender ) CLASS TForm1

   ::FPreview:SetBounds( 0, ::FBarraDeBotones:Height, ::ClientWidth, ;
                         ::ClientHeight - ::FBarraDeBotones:Height - ;
                         ::FBarraDeEstado:Height )

return

/*
 * Evento OnCloseQuery.
 */
METHOD Form1OnCloseQuery( oSender, lCanClose ) CLASS TForm1

   If ::Menu == ::FMenuPreview
      ShowPreview( .F. )
      lCanClose := .F.
   Else
      If MessageDlg( "Esto finalizar la ejecucin del programa.", mtInformation, ;
                     mbOkCancel, poActiveCenter ) == mrOk
      Else
         lCanClose := .F.
      EndIf
   EndIf

return

/*
 * Evento MenuItem OnClick.
 */
METHOD ImprimirDatos1( oSender ) CLASS TForm1

   Local oPicture

   Printer:Title := "Datos de Cliente"
   Printer:Orientation := poPortrait
   Printer:BeginDoc()
   Printer:Font:Name := "Arial"
   Printer:NewPage()
   oPicture := TPicture():Create()
   oPicture:Bitmap:FileName := "Test.bmp"
   Printer:DrawBitmap( oPicture:Bitmap:Handle, { 16, 16, 180, 122 } )
   oPicture:Jpeg:FileName := "Test.jpg"
   Printer:DrawBitmap( oPicture:Jpeg:Handle, { 16, 140, 180, 135 } )
   oPicture:Destroy()
   Printer:EndDoc()
   Printer:Preview()

return

/*
 * Evento MenuItem OnClick.
 */
METHOD Salir( oSender ) CLASS TForm1

   ::Close()

return

/*
 * Evento MenuItem OnClick.
 */
METHOD Imprimir( oSender ) CLASS TForm1

   Printer:Print()

return

/*
 * Evento MenuItem OnClick.
 */
METHOD GeneraPdf( oSender ) CLASS TForm1

   ::FSaveDialog:FileName := Printer:Title
   
   If ::FSaveDialog:Execute()
      Printer:ToPDF( ::FSaveDialog:FileName )
      MessageDlg( "Archivo generado.", mtInformation, mbOk, poActiveCenter )
   EndIf

return

/*
 * Evento OnClick.
 */
METHOD PaginaCompleta() CLASS TForm1

   ::FPaginaCompleta:Down := .T.
   ::FPreview:ViewFullSize()

return

/*
 * Evento OnClick.
 */
METHOD PaginaNormal() CLASS TForm1

   ::FPaginaNormal:Down := .T.
   ::FPreview:ViewNormal()

return

/*
 * Evento OnClick.
 */
METHOD PaginaZoom() CLASS TForm1

   ::FPaginaZoom:Down := .T.
   ::FPreview:ViewZoom()

return

/*
 * Evento OnClick.
 */
METHOD PrimeraPagina() CLASS TForm1

   ::FPreview:Page := 1

return

/*
 * Evento OnClick.
 */
METHOD PaginaAnterior() CLASS TForm1

   ::FPreview:Page--

return

/*
 * Evento OnClick.
 */
METHOD PaginaSiguiente() CLASS TForm1

   ::FPreview:Page++

return

/*
 * Evento MenuItem OnClick.
 */
METHOD UltimaPagina( oSender ) CLASS TForm1

   ::FPreview:Page := ::FPreview:Pages

return

/*
 * Muestra los controles para visualizar los documentos.
 */
static Procedure ShowPreview( lShow )

   Static cCaption, oMenu

   If lShow
      Form1:FPreview:Visible := .T.
      Form1:FPreview:SetFocus()
      Form1:FBarraDeBotones:Visible := .F.
      Form1:FPaginaNormal:Down := .T.
      Form1:FBarraDeBotonesPreview:Visible := .T.
      Form1:FBarraDeEstadoPreview:Visible := .T.
      Form1:FBarraDeEstado:Visible := .F.
      Form1:FPaginas:Caption := "Total " + LTrim( Transform( Form1:FPreview:Pages, "@E 999,999" ) )
      cCaption := Form1:Caption
      Form1:Caption := Printer:Title
      oMenu := Form1:Menu
      Form1:Menu := Form1:FMenuPreview
   Else
      Form1:FPreview:Visible := .F.
      Form1:FBarraDeBotonesPreview:Visible := .F.
      Form1:FBarraDeBotones:Visible := .T.
      Form1:FBarraDeEstado:Visible := .T.
      Form1:FBarraDeEstadoPreview:Visible := .F.
      Form1:Caption := cCaption
      Form1:Menu := oMenu
      Form1:Form1OnResize()
   EndIf

Return